//+------------------------------------------------------------------+
//|                                                 QQE Alert v3.mq4 |
//|                                                    Skyline, 2007 |
//|                                             www.forexpertutti.it |
//+------------------------------------------------------------------+
#property copyright "Skyline, 2007"
#property link      "www.forexpertutti.it"

#property indicator_chart_window

#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
//extern string Comment1             = "QQEA Alert v3 compiled by Skyline on 31 Oct 2007";
//extern string Comment2             = "modded by trendchaser";
//extern string Comment3             = "email : glicci@yahoo.it"; 

extern bool   use_atr     = false;
extern int    atr               = 2; 
extern int    atr2               = 15; 

extern bool   volatility     = false;
extern int    back  = 30;


extern bool   hilo     = false;
extern int    bars_back  = 20;
extern int    hilo_ma  = 300;
 bool   rev     = false;
extern string b             = "-------------------------------";
extern int    buy_sl_distance               = 9; // pips for anaconda (9)
extern int    sell_sl_distance               = -9; // pips for anaconda (-9)

extern string c             = "-------------------------------"; 
extern bool   use_anaconda     = true;
extern int    anaconda               = 9;  // is a sma, shifted 1

extern string d             = "-------------------------------"; 
extern bool   use_dmi     = true;//
extern int DMI_Smooth   = 14;
extern int    dmi_level       = 20;

extern string e             = "-------------------------------"; 
extern bool   use_momentum     = true;//
extern int MomPeriod=10;
extern double Mom_level_buy=0;
extern double Mom_level_sell=0;

extern string f             = "-------------------------------"; 
extern bool   use_gann     = false;//
extern int gann_Period=10;
extern bool   arrows_on_gann     = false;

extern string g             = "-------------------------------"; 
extern bool   use_qqea     = true;
extern int    QQE_SF               = 1;
extern int    QQE_RSI_Period       = 14;
extern double QQE_DARFACTOR        = 3.5; 

extern string h             = "-------------------------------"; 
extern bool   use_stochastics    = false;
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;

extern string i             = "-------------------------------";
extern bool arrows_on_ma= false;
extern bool   use_ma     = false;
extern int    ma_period               = 300;// is a ema

extern string j             = "-------------------------------"; 
extern bool   use_ma2     = false;
extern int    ma_period2               = 34;// is a ema

extern string k             = "-------------------------------"; 
extern bool   use_ma3     = false;
extern int    ma_period3               = 50;// is a ema

extern string l             = "-------------------------------"; 
extern bool   use_ma4     = false;//
extern int    ma_period4               = 9;// is a ema


extern string m             = "-------------------------------"; 
extern bool   alert     = true;  // alert sound
extern bool   sound_per_bar     = true; // thump sound
extern int alert_bar= 0;  // 0= immediate   1= at bar close

extern string n             = "-------------------------------"; 
extern bool limit_bars = False;
extern int look_back   = 100;

extern string o             = "-------------------------------"; 
extern bool use_line = False;
extern int    line_Width            = 0;
extern  color    color_up = DeepSkyBlue;
extern color    color_dn = Orange;
extern color    color_none = Gray;
 
 
//+------------------------------------------------------------------+
//| do not edit                                                      |
//+------------------------------------------------------------------+
bool DMI_Hide_DI_Plus  = False;
 bool DMI_Hide_DI_Minus = False;
 bool DMI_Hide_DX   = true;
 bool DMI_Hide_ADX  = true;
 bool DMI_Hide_ADXR = true;
bool sound_long=true;
bool sound_short=true;
double CrossUp[];
double CrossDown[];
double none[];
double crossUp2[];
double crossDown2[];
double nnone2[];
static datetime alertTag = D'1980.01.01'; 
static datetime soundTag = D'1980.01.01';
static datetime emailTag = D'1980.01.01';

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(6);
//---- indicators
if(use_line){

    SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,line_Width, color_up);
    SetIndexBuffer(0, CrossUp);
    
    SetIndexStyle(1, DRAW_LINE,STYLE_SOLID,line_Width, color_dn);
    SetIndexBuffer(1, CrossDown); 
      
    SetIndexStyle(2, DRAW_LINE,STYLE_SOLID,line_Width, color_none);
    SetIndexBuffer(2, none);
    //-----------------------------------------------------------------
    SetIndexStyle(3, DRAW_ARROW, EMPTY,2, color_up);
    //SetIndexArrow(3, 159);
    SetIndexArrow(3, 160);
    SetIndexBuffer(3, crossUp2);
    
    SetIndexStyle(4, DRAW_ARROW, EMPTY,2, color_dn);
    //SetIndexArrow(4, 159);
    SetIndexArrow(4, 160);
    SetIndexBuffer(4, crossDown2); 
      
    SetIndexStyle(5, DRAW_ARROW, EMPTY,2, color_none);
    //SetIndexArrow(5, 159);
    SetIndexArrow(5, 160);
    SetIndexBuffer(5, nnone2);  
    } 
    if(!use_line){
        SetIndexStyle(0, DRAW_ARROW, EMPTY,line_Width, color_up);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, CrossUp);
    SetIndexStyle(1, DRAW_ARROW, EMPTY,line_Width, color_dn);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, CrossDown);   
    SetIndexStyle(2, DRAW_ARROW, EMPTY,line_Width, color_none);
    SetIndexArrow(2, 251);
    SetIndexBuffer(2, none); 
        //-----------------------------------------------------------------
    SetIndexStyle(3, DRAW_ARROW, EMPTY,2, color_up);
    //SetIndexArrow(3, 159);
    SetIndexArrow(3, 160);
    SetIndexBuffer(3, crossUp2);
    
    SetIndexStyle(4, DRAW_ARROW, EMPTY,2, color_dn);
    //SetIndexArrow(4, 159);
    SetIndexArrow(4, 160);
    SetIndexBuffer(4, crossDown2); 
      
    SetIndexStyle(5, DRAW_ARROW, EMPTY,2, color_none);
    //SetIndexArrow(5, 159);
    SetIndexArrow(5, 160);
    SetIndexBuffer(5, nnone2); 
    }
GlobalVariableSet("tcmi_go_long",1);
GlobalVariableSet("tcmi_go_short",1); 

    start();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
 GlobalVariableDel("tcmi_go_long"); 
GlobalVariableDel("tcmi_go_short");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int limit, i, counter;
   //double fasterEMAnow, slowerEMAnow, fasterEMAprevious, slowerEMAprevious, fasterEMAafter, slowerEMAafter;
   double fasterRSInow,slowerRSInow;
   double Range, AvgRange;
   
   int counted_bars=IndicatorCounted();
//---- check for possible errors

   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;

   if(limit_bars) limit=look_back;
   for(i = 0; i <= limit; i++) 
   {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      
double stoch,cl,op,ma,ma2,ma3,ma4,ma5,mom,gann,dmi_1,dmi_2,val3,val4,val,val2,val5,val6,hi,lo;

if (use_stochastics)stoch=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,0,MODE_MAIN,i);
//if (use_stochastics_hist)stoch=iCustom(Symbol(),0,"StochHistogram",0,StochPeriod1,DPeriod1,SlowingPeriod1,1,i);
       lo=iLow(Symbol(),0,i);
       hi=iHigh(Symbol(),0,i);
if (hilo) val6= iMA(NULL,0,hilo_ma,0,MODE_EMA,PRICE_CLOSE,i);
if (hilo)  val=High[iHighest(NULL,0,MODE_HIGH,i+bars_back,i)];
if (hilo)   val2=Low[iLowest(NULL,0,MODE_LOW,i+bars_back,i)];
if (hilo) val4=val2+val;
if (hilo) val3=val4/2;
double op_1,op_2,op_1b,op_2b;
  if (volatility) op_1=High[iHighest(NULL,0,MODE_HIGH,i+back,i)];
   if (volatility) op_2=Low[iLowest(NULL,0,MODE_LOW,i+back,i)];
  
   if (volatility) op_1b=High[iHighest(NULL,0,MODE_HIGH,i+back*2,i+back)];
   if (volatility) op_2b=Low[iLowest(NULL,0,MODE_LOW,i+back*2,i+back)];
   double res1=op_1-op_2;
    double res2=op_1b-op_2b;
    
     
       cl=iClose(NULL,0,i);
       op=iClose(NULL,0,i);
     ma= iMA(NULL,0,anaconda,1,MODE_SMA,PRICE_CLOSE,i);
     if (use_ma) ma2= iMA(NULL,0,ma_period,0,MODE_EMA,PRICE_CLOSE,i);
     if (use_ma2) ma3= iMA(NULL,0,ma_period2,0,MODE_EMA,PRICE_CLOSE,i);
     if (use_ma3) ma4= iMA(NULL,0,ma_period3,0,MODE_EMA,PRICE_CLOSE,i);
     if (use_ma4) ma5= iMA(NULL,0,ma_period4,0,MODE_EMA,PRICE_CLOSE,i);
   if (use_momentum) mom=iCustom(Symbol(),0,"MomentumVT",MomPeriod,0,i);
  
   if (use_gann||arrows_on_gann) gann=iCustom(Symbol(),0,"###Gann_HiLo_Activator_V2###",gann_Period,0,i);
   if (use_dmi) dmi_1=iCustom(Symbol(),0,"DMI",DMI_Smooth,DMI_Hide_DI_Plus,DMI_Hide_DI_Minus,DMI_Hide_DX,DMI_Hide_ADX,DMI_Hide_ADXR,0,i);

   if (use_dmi) dmi_2=iCustom(Symbol(),0,"DMI",DMI_Smooth,DMI_Hide_DI_Plus,DMI_Hide_DI_Minus,DMI_Hide_DX,DMI_Hide_ADX,DMI_Hide_ADXR,1,i);

   
   
     if (use_qqea)  fasterRSInow      = iCustom(NULL,0,"QQEA",QQE_SF,QQE_RSI_Period,QQE_DARFACTOR,0,i);
 

      if (use_qqea) slowerRSInow      = iCustom(NULL,0,"QQEA",QQE_SF,QQE_RSI_Period,QQE_DARFACTOR,1,i);

if (cl>val3) val5=val3;
if (cl<val3) val5=val3;
//if(cl<ma)sound_long=true;
//if(cl>ma)sound_short=true;

//if(dmi_1<20)sound_long=true;
//if(dmi_2<20)sound_short=true;

//if(mom<0)sound_long=true;
//if(mom>0)sound_short=true;

//if(fasterRSInow < slowerRSInow)sound_long=true;
//if(fasterRSInow > slowerRSInow)sound_short=true;
string signal="none";

////////////////////////////////////////entry

if (hilo&&cl>val3 )signal="buy";
if(!rev&&use_stochastics&&stoch>50)signal="buy";
if(use_ma&&cl>ma2 )signal="buy";
if(use_ma2&&cl>ma3 )signal="buy";
if(use_ma3&&cl>ma4 )signal="buy";
if(use_ma4&&cl>ma5 )signal="buy";
if(!rev&&use_anaconda&&lo>ma+buy_sl_distance*Point)signal="buy";
if(!rev&&use_dmi&&dmi_1>dmi_level&&dmi_1>dmi_2)signal="buy";
if(!rev&&use_momentum&&mom>Mom_level_buy)signal="buy";
if(!rev&&use_qqea&&fasterRSInow > slowerRSInow)signal="buy";
if(!rev&&use_gann&&cl > gann)signal="buy";

if(rev&&use_stochastics&&stoch>50)signal="buy";

if(rev&&use_anaconda&&lo<ma+buy_sl_distance*Point)signal="buy";
if(rev&&use_dmi&&dmi_1<dmi_level&&dmi_1<dmi_2)signal="buy";
if(rev&&use_momentum&&mom<Mom_level_buy)signal="buy";
if(rev&&use_qqea&&fasterRSInow < slowerRSInow)signal="buy";
if(rev&&use_gann&&cl < gann)signal="buy";

if (hilo&&cl<val3 )signal="sell";
if(!rev&&use_stochastics&&stoch<50)signal="sell";
if(use_ma&&cl<ma2 )signal="sell";
if(use_ma2&&cl<ma3  )signal="sell";
if(use_ma3&&cl<ma4  )signal="sell";
if(use_ma4&&cl<ma5  )signal="sell";
if(!rev&&use_anaconda&&hi<ma+sell_sl_distance*Point)  signal="sell";
if(!rev&&use_dmi&&dmi_2>dmi_level&&dmi_1<dmi_2) signal="sell";
if(!rev&&use_momentum&&mom<Mom_level_sell) signal="sell";
if(!rev&&use_qqea&&fasterRSInow < slowerRSInow) signal="sell";
if(!rev&&use_gann&&cl < gann)signal="sell";

if(rev&&use_stochastics&&stoch>50)signal="sell";
if(rev&&use_anaconda&&hi>ma+sell_sl_distance*Point)  signal="sell";
if(rev&&use_dmi&&dmi_2>dmi_level&&dmi_1>dmi_2) signal="sell";
if(rev&&use_momentum&&mom>Mom_level_sell) signal="sell";
if(rev&&use_qqea&&fasterRSInow > slowerRSInow) signal="sell";
if(rev&&use_gann&&cl > gann)signal="sell";

////////////////////////////////////////entry


//////////////////////////////////////////filter

if (hilo&&cl<val3&&signal=="buy")signal="none";
if(!rev&&use_stochastics&&stoch<50&&signal=="buy")signal="none";
if(use_ma&&cl<ma2 &&signal=="buy")signal="none";
if(use_ma2&&cl<ma3 &&signal=="buy")signal="none";
if(use_ma3&&cl<ma4 &&signal=="buy")signal="none";
if(use_ma4&&cl<ma5 &&signal=="buy")signal="none";
if(!rev&&use_anaconda&&signal=="buy"&&lo<ma+buy_sl_distance*Point)signal="none";
if(!rev&&use_dmi&&signal=="buy"&&dmi_1<dmi_level)signal="none";
if(!rev&&use_momentum&&signal=="buy"&&mom<Mom_level_buy)signal="none";
if(!rev&&use_qqea&&signal=="buy"&&fasterRSInow < slowerRSInow)signal="none";
if(!rev&&signal=="buy"&&use_gann&&cl < gann)signal="none";

if(rev&&use_stochastics&&stoch>50&&signal=="buy")signal="none";
if(rev&&use_anaconda&&signal=="buy"&&lo>ma+buy_sl_distance*Point)signal="none";
if(rev&&use_dmi&&signal=="buy"&&dmi_1>dmi_level)signal="none";
if(rev&&use_momentum&&signal=="buy"&&mom>Mom_level_buy)signal="none";
if(rev&&use_qqea&&signal=="buy"&&fasterRSInow > slowerRSInow)signal="none";
if(rev&&signal=="buy"&&use_gann&&cl > gann)signal="none";

if (hilo&&cl>val3&&signal=="sell")signal="none";
if(!rev&&use_stochastics&&stoch>50&&signal=="sell")signal="none";
if(use_ma&&cl>ma2  &&signal=="sell")signal="none";
if(use_ma2&&cl>ma3  &&signal=="sell")signal="none";
if(use_ma3&&cl>ma4  &&signal=="sell")signal="none";
if(use_ma4&&cl>ma5  &&signal=="sell")signal="none";
if(!rev&&use_anaconda&&signal=="sell"&&hi>ma+sell_sl_distance*Point)signal="none";
if(!rev&&use_dmi&&signal=="sell"&&dmi_2<dmi_level)signal="none";
if(!rev&&use_momentum&&signal=="sell"&&mom>Mom_level_sell)signal="none";
if(!rev&&use_qqea&&signal=="sell"&&fasterRSInow > slowerRSInow)signal="none";  
if(!rev&&signal=="sell"&&use_gann&&cl > gann)signal="none";

if(rev&&use_stochastics&&stoch<50&&signal=="sell")signal="none";

if(rev&&use_anaconda&&signal=="sell"&&hi<ma+sell_sl_distance*Point)signal="none";
if(rev&&use_dmi&&signal=="sell"&&dmi_2<dmi_level)signal="none";
if(rev&&use_momentum&&signal=="sell"&&mom<Mom_level_sell)signal="none";
if(rev&&use_qqea&&signal=="sell"&&fasterRSInow < slowerRSInow)signal="none";  
if(rev&&signal=="sell"&&use_gann&&cl < gann)signal="none";
if (use_atr&&iATR(NULL,0,atr,i)<iATR(NULL,0,atr2,i))signal="none";
if (volatility&&res2>res1) signal="none";
 //////////////////////////////////////////filter
 double line; 
 
 line=ma;
 if (use_anaconda)line=ma;
  if (!use_anaconda&&use_ma)line=ma2;
   if (!use_anaconda&&!use_ma&&use_ma2)line=ma3; 
    if (!use_anaconda&&!use_ma&&!use_ma2&&!use_gann)line=ma;
    if (!use_anaconda&&!use_ma&&!use_ma2&&use_gann)line=gann;
    if (arrows_on_gann)line=gann;
     if (arrows_on_ma)line=ma2;
     //if (hilo)line=val5;
if(signal=="buy") {CrossUp[i] = line+buy_sl_distance*Point;sound_short=true; }
if(signal=="sell") {CrossDown[i] = line+sell_sl_distance*Point ;sound_long=true; }
if(signal=="none"){ none[i] = line ;}
if(signal!="buy"&&signal!="sell"){ none[i] = line ;}

 //if(i==alert_bar&&signal=="buy")    GlobalVariableSet("tcmi_go_long",2); 
 // if(i==alert_bar&&signal=="sell")    GlobalVariableSet("tcmi_go_short",2); 
     if(i==alert_bar&&signal=="buy"){
     GlobalVariableSet("tcmi_go_long",2);
     GlobalVariableSet("tcmi_go_short",1);
     }    
      if(i==alert_bar&&signal=="sell"){
     GlobalVariableSet("tcmi_go_long",1);
     GlobalVariableSet("tcmi_go_short",2);
     }   
    if(i==alert_bar&&signal=="none")  GlobalVariableSet("tcmi_sl",NormalizeDouble(line,Digits)); 
     if(i==alert_bar&&signal=="buy")  GlobalVariableSet("tcmi_sl",NormalizeDouble(line,Digits)); 
  if(i==alert_bar&&signal=="sell")  GlobalVariableSet("tcmi_sl",NormalizeDouble(line,Digits)); 


       if (sound_short && alert && signal=="sell"&& i==alert_bar)
        {
         PlaySound ("alert.wav");
         GlobalVariableSet("tcmi_go_short",2);
GlobalVariableSet("tcmi_go_long",1);
        }
        if (sound_long && alert && signal=="buy"&& i==alert_bar)
        {
         PlaySound ("alert.wav");
         GlobalVariableSet("tcmi_go_long",2);
GlobalVariableSet("tcmi_go_short",1);
        } 
        
        //////////////////////////////////////////////////////////////////////////
     
        if (sound_per_bar && i==alert_bar && signal=="sell" && soundTag!=Time[0])
        {
        if (!alert)PlaySound ("short.wav");
        if (alert&&!sound_short)PlaySound ("short.wav");
         soundTag = Time[0];
              GlobalVariableSet("tcmi_go_long",1);
     GlobalVariableSet("tcmi_go_short",2);

        }
        if (sound_per_bar&& i==alert_bar && signal=="buy" && soundTag!=Time[0])
        {
         if (!alert)PlaySound ("long.wav");
         if (alert&&!sound_long)PlaySound ("long.wav");
         soundTag = Time[0];
         
         GlobalVariableSet("tcmi_go_long",2);
     GlobalVariableSet("tcmi_go_short",1);
        } 
        
 if (sound_short && alert && signal=="sell"&& i==alert_bar)
        {
         crossDown2[i] = op ;
         sound_long=true;
         sound_short=false;
        }
        if (sound_long && alert && signal=="buy"&& i==alert_bar)
        {
        crossUp2[i] = op;
         sound_long=false;
         sound_short=true;
        } 

  }
   return(0);
}


